# class Event

#### package js.html

#### extended by ClipboardEvent, UIEvent

Available on HTML5

The `Event` interface represents any event which takes place in the DOM; some are user-generated (such as mouse or keyboard events), while others are generated by APIs (such as events that indicate an animation has finished running, a video has been paused, and so forth). There are many types of event, some of which use are other interfaces based on the main `Event` interface. `Event` itself contains the properties and methods which are common to all events.

Documentation Event by Mozilla Contributors, licensed under CC-BY-SA 2.5.

See:

https://developer.mozilla.org/en-US/docs/Web/API/Event

### Constructor

###

`new (type:String, ?eventInitDict:EventInit)`

Throws:

`null` | DOMError

### Variables

###

`read onlybubbles:Bool`

A Boolean indicating whether the event bubbles up through the DOM or not.

###

`read onlycancelable:Bool`

A Boolean indicating whether the event is cancelable.

###

`read onlycurrentTarget:EventTarget`

A reference to the currently registered target for the event. This is the object to which the event is currently slated to be sent to; it's possible this has been changed along the way through retargeting.

###

`read onlydefaultPrevented:Bool`

Indicates whether or not `event.preventDefault()` has been called on the event.

###

`read onlyeventPhase:Int`

Indicates which phase of the event flow is being processed.

###

`read onlyexplicitOriginalTarget:EventTarget`

The explicit original target of the event (Mozilla-specific).

###

`read onlyisTrusted:Bool`

Indicates whether or not the event was initiated by the browser (after a user click for instance) or by a script (using an event creation method, like event.initEvent)

###

`read onlyoriginalTarget:EventTarget`

The original target of the event, before any retargetings (Mozilla-specific).

###

`read onlytarget:EventTarget`

A reference to the target to which the event was originally dispatched.

###

`read onlytimeStamp:Float`

The time at which the event was created, in milliseconds. By specification, this value is time since epoch, but in reality browsers' definitions vary; in addition, work is underway to change this to be a `DOMHighResTimeStamp` instead.

###

`read onlytype:String`

The name of the event (case-insensitive).

### Methods

###

`getPreventDefault ():Bool`

Non-standard. Returns the value of `Event.defaultPrevented`. Use `Event.defaultPrevented` instead.

###

`initEvent (type:String, bubbles:Bool, cancelable:Bool):Void`

Initializes the value of an Event created. If the event has already being dispatched, this method does nothing.

###

`preventDefault ():Void`

Cancels the event (if it is cancelable).

###

`stopImmediatePropagation ():Void`

For this particular event, no other listener will be called. Neither those attached on the same element, nor those attached on elements which will be traversed later (in capture phase, for instance)

###

`stopPropagation ():Void`

Stops the propagation of events further along in the DOM.

### Static variables

###

`staticinline read onlyALT_MASK:Int = 1`

###

`staticinline read onlyAT_TARGET:Int = 2`

###

`staticinline read onlyBUBBLING_PHASE:Int = 3`

###

`staticinline read onlyCAPTURING_PHASE:Int = 1`

###

`staticinline read onlyCONTROL_MASK:Int = 2`

###

`staticinline read onlyMETA_MASK:Int = 8`

###

`staticinline read onlyNONE:Int = 0`

###

`staticinline read onlySHIFT_MASK:Int = 4`